/******************************************************************************
DtK - DJedi Tool Kit. Un tool kit X Window
Copyright (C) 1998-1999 Valvassori Moise (djedi@citeweb.net)

Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon
les termes de la Licence Publique Gnrale GNU publie par la Free Software
Foundation (version 2 ou bien toute autre version ultrieure choisie par
vous).

Ce programme est distribu car potentiellement utile, mais SANS AUCUNE
GARANTIE, ni explicite ni implicite, y compris les garanties de
commercialisation ou d'adaptation dans un but spcifique. Reportez-vous  la
Licence Publique Gnrale GNU pour plus de dtails.

Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme
temps que ce programme ; si ce n'est pas le cas, crivez  la Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307,
tats-Unis.
******************************************************************************/
/**********************************
 ************** Button ************
 **********************************/
#define DJedi_button

#include <stdio.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <stdlib.h>
#include "dtk.h"
#include "form.h"

extern Display *display;
extern XFontStruct *struct_font;
extern void nop();

void _button_redraw(Form *n,BMode type)
{
  char *text;
  int dummy,x,y,w,h;
  int largeur;
  int tcolor;
 
  XGetGeometry(display,n->window,(Window *)&dummy,&x,&y,&w,&h,&dummy,&dummy); 
  text=n->type.button.text; 
  /* _Box(n,x,y,w,h,type); */
  largeur=XTextWidth(struct_font,text,strlen(text));
  if (is_able(n)==true){
    _Box(n,x,y,w,h,type);
    tcolor=TEXT_COLOR;}
  else {
    _Box(n,x,y,w,h,mdisabled);
    tcolor=DISABLED_TEXT_COLOR;}
  color(n,tcolor);
  XDrawString(display,n->window,n->gc,(w-largeur)/2,(h+struct_font->ascent)/2,text,strlen(text));
}

void button_redraw(Form *n){
  if (is_able(n)==true)
    _button_redraw(n,normal);
  else
    _button_redraw(n,mdisabled);
}

void button_press(Form *n){
  if (is_able(n)==true)
    _button_redraw(n,press); }

void button_release(Form *i){
  if (is_able(i)==true){
    _button_redraw(i,in);
    i->action(i);}
}

void button_enter(Form *n) {
  if (is_able(n)==true)
    _button_redraw(n,in); }

Form *button(Form *parent,int x,int y,uint l,uint h,char * title,void (*action)(Form *form))
{
  Form *form;
  form=_open_form(parent,x,y,l,h,1);
  
  if (action!=NULL)  /* Installe l'action du button cliquer */
    form->action=action;
  
  form->istype=tbutton;
  form->redraw=button_redraw;
  form->enter=button_enter;
  form->leave=button_redraw;
  form->release=button_release;
  form->press=button_press;
  form->type.button.text=(char *)malloc(strlen(title)+1);
  strcpy(form->type.button.text,title);   /* Copie le texte du button */   

  XSelectInput(display,form->window, 
	       ExposureMask|
	       ButtonPressMask|ButtonReleaseMask|
	       EnterWindowMask|LeaveWindowMask);	/* masque evnt */
  return form;
}
