/******************************************************************************
DtK - DJedi Tool Kit. Un tool kit X Window
Copyright (C) 1998-1999 Valvassori Moise (djedi@citeweb.net)

Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon
les termes de la Licence Publique Gnrale GNU publie par la Free Software
Foundation (version 2 ou bien toute autre version ultrieure choisie par
vous).

Ce programme est distribu car potentiellement utile, mais SANS AUCUNE
GARANTIE, ni explicite ni implicite, y compris les garanties de
commercialisation ou d'adaptation dans un but spcifique. Reportez-vous  la
Licence Publique Gnrale GNU pour plus de dtails.

Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme
temps que ce programme ; si ce n'est pas le cas, crivez  la Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307,
tats-Unis.
******************************************************************************/
/******************************************************************************
               Check Box
               Petite boite avec un croix dedans
******************************************************************************/
#define DJedi_check

#include <stdio.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <stdlib.h>
#include "dtk.h"
#include "form.h"

extern Display *display;
extern XFontStruct *struct_font;
extern void nop();

/*   distance entre la croix et le bord du cadre */
#define offset 2

static void _check_redraw(Form *n,BMode type)
{
  int dummy,x,y,w,h,tcolor;
 char *text;

 XGetGeometry(display,n->window,(Window *)&dummy,&x,&y,&w,&h,&dummy,&dummy); 
 if (type==normal)
   color(n,BG_COLOR);
 else if(is_able(n)==false)
   color(n,DISABLED_BG_COLOR);
 else
   color(n,MOUSEON_BG_COLOR);  
 rectf(n,0,0,w,h);  /*   fond */

 color(n,LIGTH_COLOR);
 rectf(n,2,h/2-5,13,h/2+6);  /*   carre */
 color(n,DARK_COLOR);
 rect(n,1,h/2-6,13,h/2+6);
 if (n->type.check.value==true)
   {
     line(n,2+offset,h/2-5+offset,13-offset,h/2+6-offset);
     line(n,13-offset,h/2-6+offset,2+offset,h/2+5-offset);
   }

 text=n->type.check.text;
 if (is_able(n)==true)
   tcolor=TEXT_COLOR;
 else
   tcolor=DISABLED_TEXT_COLOR;
 color(n,tcolor);
 XDrawString(display,n->window,n->gc,20,(h+struct_font->ascent)/2,text,strlen(text));
}

void check_redraw(Form *n){
  _check_redraw(n,normal);}

void check_enter(Form *n){
  if(is_able(n)==true)
    _check_redraw(n,in);}

void check_release(Form *n)
{
  if (is_able(n)){
    if (n->type.check.value==true)
      n->type.check.value=false;
    else
      n->type.check.value=true;
    
    _check_redraw(n,in);
    n->action(n);
  }
}
Form *check(Form * parent,int x,int y,uint l, uint h,char *title,boolean value)
{
  Form *form;
  form=_open_form(parent,x,y,l,h,0);

  form->istype=tcheck;
  form->redraw=check_redraw;
  form->enter=check_enter;
  form->leave=check_redraw;
  form->release=check_release;
  form->press=nop;
  form->type.check.value=value;
  form->type.check.text=(char *)malloc(strlen(title)+1);
  strcpy(form->type.check.text,title);

 XSelectInput(display,form->window, 
	      ExposureMask|
	      EnterWindowMask|LeaveWindowMask|
	      ButtonReleaseMask|ButtonPressMask);	/* masque evnt */
 return form;
}

boolean get_check(Form *f)
{
  if (f->istype==tcheck)
    return f->type.check.value;
  else
    return false;
}

boolean set_check(Form *f,boolean v)
{
  if (f->istype==tcheck){
    f->type.check.value=v;
    _check_redraw(f,normal);
    return f->type.check.value;
  }
  else
    return false;
}

char *set_check_text(Form *f,char * text)
{
  if (f->istype==tcheck){
    strcpy(f->type.check.text,text);
    _check_redraw(f,normal);
    return f->type.input.text;
  }
  else
    return NULL;
}

