/******************************************************************************
DtK - DJedi Tool Kit. Un tool kit X Window
Copyright (C) 1998-1999 Valvassori Moise (djedi@citeweb.net)

Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon
les termes de la Licence Publique Gnrale GNU publie par la Free Software
Foundation (version 2 ou bien toute autre version ultrieure choisie par
vous).

Ce programme est distribu car potentiellement utile, mais SANS AUCUNE
GARANTIE, ni explicite ni implicite, y compris les garanties de
commercialisation ou d'adaptation dans un but spcifique. Reportez-vous  la
Licence Publique Gnrale GNU pour plus de dtails.

Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme
temps que ce programme ; si ce n'est pas le cas, crivez  la Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307,
tats-Unis.
******************************************************************************/
/******************************************************************************
               Dfinition "formelle" des formulaires.
******************************************************************************/
#define DJedi_form

#include <stdio.h>
#include <stdlib.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include "dtk.h"
#include "form.h"

extern void nop();
boolean is_able(Form *f);

Form* _open_form(Form * parent,int x,int y,uint l,uint h,int bord)
{
  XSizeHints size;
  uint	n,b;
  Form*form;

  form=(Form*)malloc(sizeof(Form));
  end_lst_obj->next=form;		/*  Chaine la liste des formulaire  */
  end_lst_obj=form;
  form->next=NULL;

  b=WhitePixel(display,ecran);
  n=BlackPixel(display,ecran);		/* chope les couleurs noire et blanche */

  form->x=x;
  form->y=y;
  form->w=l;
  form->h=h; 

  form->parent=parent;			/* set la fenetre mre */
  form->state.disabled=0;
  form->action=nop;
  form->popup=NULL;

  size.x=x;   size.y=y;			/* fixe la taille de la window */
  size.width=l;	size.height=h;
  size.flags=PPosition | PSize;
 
 /* ouvre la window */
 form->window = XCreateSimpleWindow(display,parent->window,
					size.x,size.y,size.width,size.height,bord,n,n);
 
 XMapRaised(display,form->window);	
 /* La window est visible maintenant	*/
 
 form->gc = XCreateGC(display,form->window,0,NULL); /* cree le graphic context */
 XSetBackground(display,form->gc,n);
 XSetForeground(display,form->gc,b);
 XSetLineAttributes(display,form->gc,1,LineSolid,CapButt,JoinBevel); 

 XSetFont(display,form->gc,font);

 return form;
}


void _Box(Form*fen,int x,int y,int w,int h,BMode mode)
{

  if (mode==normal)
    color(fen,BG_COLOR);
  else if (mode==press)
    color(fen,MOUSEPRESS_BG_COLOR);
  else if (mode==mdisabled)
    color(fen,DISABLED_BG_COLOR);
  else
    color(fen,MOUSEON_BG_COLOR);
  rectf(fen,1,1,w-1,h-1);

  if (mode!=press)
    color(fen,LIGTH_COLOR1);
  else
    color(fen,DARK_COLOR1);
  line(fen,0,0,w-1,0);
  line(fen,0,1,0,h-1);

  if (mode!=press)
    color(fen,DARK_COLOR1);
  else
    color(fen,LIGTH_COLOR1);
  line(fen,w-1,0,w-1,h);
  line(fen,0,h-1,w-1,h-1);

  if (mode!=press)
    color(fen,LIGTH_COLOR2);
  else
    color(fen,DARK_COLOR2);
  line(fen,1,1,w-2,1);
  line(fen,1,2,1,h-2);

  if (mode!=press)
    color(fen,DARK_COLOR2);
  else
    color(fen,LIGTH_COLOR2);
  line(fen,w-2,1,w-2,h-1);
  line(fen,1,h-2,w-2,h-2);
}

void disable(Form *f){
Form *ftmp;

 for(ftmp=start_lst_obj; (ftmp!=NULL); ftmp=ftmp->next)
   if (ftmp->parent==f)
     disable(ftmp);
 
 f->state.disabled=1;
 f->redraw(f);
}

void enable(Form *f){
Form *ftmp;

 for(ftmp=start_lst_obj; (ftmp!=NULL); ftmp=ftmp->next)
   if (ftmp->parent==f)
     enable(ftmp);

 f->state.disabled=0;
 f->redraw(f);
}

boolean is_able(Form *f){
  if (f->state.disabled)
    return (false);
  else
    return (true);
}

void set_action (Form *f,void (*action)(struct FORM *i)){
  f->action=action;
}

