/******************************************************************************
DtK - DJedi Tool Kit. Un tool kit X Window
Copyright (C) 1998-1999 Valvassori Moise (djedi@citeweb.net)

Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon
les termes de la Licence Publique Gnrale GNU publie par la Free Software
Foundation (version 2 ou bien toute autre version ultrieure choisie par
vous).

Ce programme est distribu car potentiellement utile, mais SANS AUCUNE
GARANTIE, ni explicite ni implicite, y compris les garanties de
commercialisation ou d'adaptation dans un but spcifique. Reportez-vous  la
Licence Publique Gnrale GNU pour plus de dtails.

Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme
temps que ce programme ; si ce n'est pas le cas, crivez  la Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307,
tats-Unis.
******************************************************************************/
/******************************************************************************
               Frame buffer
******************************************************************************/
#include "../config.h"
#ifdef HAVE_LINUX_FB_H
#define DJedi_framebuffer

#include <linux/fb.h>
#include <unistd.h>
#include <sys/mman.h>
#include <fcntl.h>
#include <errno.h>
#include <string.h>

#include <stdio.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <stdlib.h>
#include "dtk.h"
#include "form.h"

extern Display *display;
extern XFontStruct *struct_font;
extern void nop();

/*  #define W 1280
 *  #define H 1024 */

static size_t size;;
static int W,H;

void
DtKAbsolute(Form * f,int *x,int *y)
{
  int dummy,xi,yi,w,h;

  *x = 0;
  *y = 0;

  while (f->parent != NULL) {
    *x = *x + f->x;
    *y = *y + f->y;
    f= f->parent;
  }


  printf(">> %d",f->istype);
  XGetGeometry(display,f->window,(Window *)&dummy,&xi,&yi,&w,&h,&dummy,&dummy); 
  *x = *x + xi;
  *y = *y + yi;
}


Form *framebuffer(Form * parent,int x,int y,uint l,uint h,void (*redraw)(Form *form))
{
  Form *form;
  int fd;
  void * fb;
  int xa,ya;

  fd= open("/dev/fb0",O_RDWR); 
  if ((int)fd == -1){
    perror(strerror(errno));
    exit(2);
  }

  W = XDisplayWidth(display,0);
  H = XDisplayHeight(display,0);
  size = H*W*2;


  fb = mmap(NULL,size,PROT_READ|PROT_WRITE,MAP_SHARED,fd,0); //(W*y+x)*2);
  if ((int)fb == -1) {
    perror(strerror(errno));
    exit(2);
  }



  form=_open_form(parent,x,y,l,h,0);
  
  if (redraw==NULL)
    form->redraw=nop;
  else
    form->redraw=redraw;


  DtKAbsolute(form,&xa,&ya);
  printf(">%d %d\n",xa,ya);


  form->istype=tframebuffer;
  form->enter=nop;
  form->leave=nop;
  form->release=nop;
  form->press=nop;
  
  XSelectInput(display,form->window, 
	       ExposureMask|
	       ButtonPressMask|ButtonReleaseMask|
	       EnterWindowMask|LeaveWindowMask);	/* masque evnt */

  form->type.framebuffer.buffer = fb;
  form->type.framebuffer.fb = fb+(W*y+x)*2;
  
  
  return form;
}
#endif HAVE_LINUX_FB_H
