/******************************************************************************
DtK - DJedi Tool Kit. Un tool kit X Window
Copyright (C) 1998-1999 Valvassori Moise (djedi@citeweb.net)

Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon
les termes de la Licence Publique Gnrale GNU publie par la Free Software
Foundation (version 2 ou bien toute autre version ultrieure choisie par
vous).

Ce programme est distribu car potentiellement utile, mais SANS AUCUNE
GARANTIE, ni explicite ni implicite, y compris les garanties de
commercialisation ou d'adaptation dans un but spcifique. Reportez-vous  la
Licence Publique Gnrale GNU pour plus de dtails.

Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme
temps que ce programme ; si ce n'est pas le cas, crivez  la Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307,
tats-Unis.
******************************************************************************/
/**********************************
 ************** Input *************
 **********************************/
#define DJedi_input

#include <stdio.h>
#include <string.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/keysym.h>
#include <stdlib.h>
#include "dtk.h"

extern Display *display;
extern XFontStruct *struct_font;

void input_redraw(Form *n)
{
  int ppos,*offset;
  char *text;
  int dummy,x,y,w,h,tcolor;
  
  XGetGeometry(display,n->window,(Window *)&dummy,&x,&y,&w,&h,&dummy,&dummy); 
  color(n,BGINPUT_COLOR);
  rectf(n,1,1,w-2,h-2);

  text=n->type.input.text;
 if (is_able(n)==true)
   tcolor=TEXTINPUT_COLOR;
 else{
   tcolor=DISABLED_TEXT_COLOR;
 }
 color(n,tcolor);
  ppos=XTextWidth(struct_font,text,n->type.input.pos);
  offset=&n->type.input.offset;

  if (*offset+ppos>w-8) /* check if pointer is over the frame */
    *offset=w-8-ppos;
  if (*offset+ppos<0) /* check if pointer is over the frame */
    *offset=-ppos;

  XDrawString(display,n->window,n->gc,4+*offset,(h+struct_font->ascent)/2,text,strlen(text));
  if ((n->type.input.focus==true)&&(is_able(n)==true))
    rectf(n,4+ppos+*offset,3,5+ppos+*offset,h-3);

  color(n,DARK_COLOR1);
  line(n,0,0,w-1,0);
  line(n,0,1,0,h-1);
  color(n,LIGTH_COLOR1);
  line(n,w-1,0,w-1,h);
  line(n,0,h-1,w-1,h-1);
  color(n,DARK_COLOR2);
  line(n,1,1,w-2,1);
  line(n,1,2,1,h-2);
  color(n,LIGTH_COLOR2);
  line(n,w-2,1,w-2,h-1);
  line(n,1,h-2,w-2,h-2);
}

void input_press(Form *f){
  if (is_able(f)==true)
    XSetInputFocus(display,f->window,RevertToPointerRoot,CurrentTime);
}

void input_kb(Form *f,XKeyEvent *event) {
  char tab[33],*text,*t;
  KeySym ks;
  int n,*pos;
  boolean flag=true; /* if flag==false then no redraw required */

  if ((f->type.input.focus==true)&&(is_able(f)==true)){
    n=XLookupString(event,tab,32,&ks,NULL);
    text=f->type.input.text;
    pos=&f->type.input.pos;
    switch (ks){
    case XK_BackSpace :
      if (*pos>0){
	strcpy(text+*pos-1,text+*pos); /* efface un caractre */
	*pos-=1;
      }
      else flag=false;
      break;
    case XK_Delete :
      if (*pos<strlen(text)){
	strcpy(text+*pos,text+*pos+1); /* efface un caractre */
      }
      else flag=false;
      break;
    case XK_Left :
      if (*pos>0)
	*pos-=1;
      else
	flag=false;
      break;
    case XK_Right :
      if (*pos<strlen(text))
	*pos+=1;
      else flag=false;
      break;
    default:
      if ((n==1) && (strlen(text)<MAX_TEXT)){
	for (t=text+strlen(text); t>=text+*pos; t--){
	  *(t+1)=*t;
	}
	*(text+*pos)=*tab;
	*pos+=n;
      }
      else flag=false;
    }
    if (flag==true)
      input_redraw(f);
  }
}

void input_focus(Form *f,boolean focus) {
    f->type.input.focus=focus;
  if (is_able(f)==true){
    input_redraw(f);}
}

Form  *input(Form * parent,int x,int y,uint l,uint h,char *text)
{
  Form *form;
  form=_open_form(parent,x,y,l,h,1);
  
  form->istype=tinput;
  form->redraw=input_redraw;
  form->press=input_press;
  form->kpress=input_kb;
  form->focus=input_focus;
  form->type.input.text=(char *)malloc(MAX_TEXT+1);
  strcpy(form->type.input.text,text);
  form->type.input.focus=false;
  form->type.input.pos=strlen(text);
  form->type.input.offset=0;
  XSelectInput(display,form->window, 
	       ExposureMask|KeyPressMask|ButtonPressMask|FocusChangeMask);	/* masque evnt */
  return form;
}

char *get_input_text(Form *f)
{
  if (f->istype==tinput)
    return f->type.input.text;
  else
    return NULL;
}
char *set_input_text(Form *f,char * text)
{
  if (f->istype==tinput){
    strcpy(f->type.input.text,text);
    if (f->type.input.pos>strlen(text))
      f->type.input.pos=strlen(text);
    input_redraw(f);
    return f->type.input.text;
  }
  else
    return NULL;
}


