/******************************************************************************
DtK - DJedi Tool Kit. Un tool kit X Window
Copyright (C) 1998-2000 Valvassori Moise (djedi@citeweb.net)

Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon
les termes de la Licence Publique Gnrale GNU publie par la Free Software
Foundation (version 2 ou bien toute autre version ultrieure choisie par
vous).

Ce programme est distribu car potentiellement utile, mais SANS AUCUNE
GARANTIE, ni explicite ni implicite, y compris les garanties de
commercialisation ou d'adaptation dans un but spcifique. Reportez-vous  la
Licence Publique Gnrale GNU pour plus de dtails.

Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme
temps que ce programme ; si ce n'est pas le cas, crivez  la Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307,
tats-Unis.
******************************************************************************/
			     /*********************** 
                              *  Easy Pixmap	    * 
                              ***********************/

#define DJedi_pixmap

#include <stdio.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <malloc.h>
#include <X11/xpm.h>
#include "dtk.h"
#include "form.h"

extern Display *display;
extern XFontStruct *struct_font;

Form *
pixmap(Form *parent,int x,int y,uint l,uint h)
{
  Form *form;
  
  form=(Form*)malloc(sizeof(Form));
  end_lst_obj->next=form;		/*  Chaine la liste des formulaire  */
  end_lst_obj=form;
  form->next=NULL;
  
  form->x=x;
  form->y=y;
  form->w=l;
  form->h=h; 
  
  form->parent=parent;			/* set la fenetre mre */
  form->state.disabled=0;
  form->action=nop;
  form->popup=NULL;

  form->type.pixmap.pixmap = XCreatePixmap(display,parent->window,l,h,DefaultDepth(display, DefaultScreen(display)));
  form->gc = XCreateGC(display,form->type.pixmap.pixmap,0,NULL); /* cree le graphic context */

  form->window=form->type.pixmap.pixmap;

  form->istype=tpixmap;
  /*  form->redraw=pixmap_redraw; */

  return form;
}

Form *
pixmapxpm(Form *parent,int x,int y,char * file)
{
  Form *form;
  Pixmap mask;
  XpmAttributes attr;
  int error;

  form=(Form*)malloc(sizeof(Form));
  end_lst_obj->next=form;		/*  Chaine la liste des formulaire  */
  end_lst_obj=form;
  form->next=NULL;
  
  form->parent=parent;			/* set la fenetre mre */
  form->state.disabled=0;
  form->action=nop;
  form->popup=NULL;

  attr.valuemask = 0;
  error=XpmReadFileToPixmap(display,parent->window,file,&form->type.pixmap.pixmap,&mask,&attr);

  if (error == XpmColorError)
    {
      fprintf(stderr,"XPM Load: Color Error\n");  
      return (NULL);
    }
  else if (error == XpmOpenFailed)
    {
      fprintf(stderr,"XPM Load: Open %s Failed\n",file);
      return (NULL);
    }
  else if (error == XpmFileInvalid)
    {
      fprintf(stderr,"XPM Load: %s is invalid\n",file);
      return (NULL);
    }
  else if (error == XpmNoMemory)
    {
      fprintf(stderr,"XPM Load: No memory\n");
      return (NULL);
    }
  else if (error == XpmColorFailed)
    {
      fprintf(stderr,"XPM Load: No Color\n");
      return (NULL);
    }

   form->x=x;
   form->y=y;
   form->w=attr.width;
   form->h=attr.height;
  
  form->gc = XCreateGC(display,form->type.pixmap.pixmap,0,NULL); /* cree le graphic context */
  form->window=form->type.pixmap.pixmap;

  form->istype=tpixmap;
  /*  form->redraw=pixmap_redraw; */

  return form;
}





/*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  Flush the pixmap on the screen

  Form *f the pixmap to flush

  boolean i if true do an XFlush
  +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
void
flush_pixmap(Form *f,boolean i)
{
  XCopyArea(display,f->type.pixmap.pixmap,f->parent->window,f->gc,0,0,f->w,f->h,f->x,f->y);
  if (i)
    XFlush(display);
}




XImage *
image (Form *parent,int x,int y,uint l,uint h)
{
  XImage *xi;

  xi = XGetImage(display,parent->window,x,y,l,h,AllPlanes,ZPixmap);
  return (xi);
}


/*  void
 *  image (Form *parent,int x,int y,uint l,uint h)
 *  {
 *    XVisualInfo visual_info;
 *    char *image;
 *    int exist;
 *    XImage * xi;
 *  
 *    exist = XMatchVisualInfo(display,DefaultScreen(display),16,TrueColor,&visual_info);
 *    if (exist == 0)
 *      fprintf(stderr,"The visual does not exist\n");
 *  
 *     xi=XCreateImage(display,visual_info.visual,16,ZPixmap,0,image,l,h,l*16,l*16);
 *  
 *     printf("%p\n",xi);
 *  } */

