/******************************************************************************
DtK - DJedi Tool Kit. Un tool kit X Window
Copyright (C) 1998-1999 Valvassori Moise (djedi@citeweb.net)

Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon
les termes de la Licence Publique Gnrale GNU publie par la Free Software
Foundation (version 2 ou bien toute autre version ultrieure choisie par
vous).

Ce programme est distribu car potentiellement utile, mais SANS AUCUNE
GARANTIE, ni explicite ni implicite, y compris les garanties de
commercialisation ou d'adaptation dans un but spcifique. Reportez-vous  la
Licence Publique Gnrale GNU pour plus de dtails.

Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme
temps que ce programme ; si ce n'est pas le cas, crivez  la Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307,
tats-Unis.
******************************************************************************/
/******************************************************************************
               Dfinition des popups
******************************************************************************/
#define DJedi_popup

#include <stdio.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <stdlib.h>
#include "dtk.h"
#include "form.h"

extern Display *display;
extern XFontStruct *struct_font;
extern void nop();
extern Form * princ;

#define HSPACE 4

void _pp_item_redraw(Form *n,BMode type)
{
  char *text;
  int dummy,x,y,w,h;
  int largeur;
  int tcolor;
 
  XGetGeometry(display,n->window,(Window *)&dummy,&x,&y,&w,&h,&dummy,&dummy); 
  if (type==in)
    color(n,MOUSEON_BG_COLOR);
  else if (type==press)
    color(n,MOUSEPRESS_BG_COLOR);
  else
    color(n,BG_COLOR);

  rectf(n,0,0,w,h);					    /*   fond */

  text=n->type.pp_item.text; 
  /* _Box(n,x,y,w,h,type); */
  largeur=XTextWidth(struct_font,text,strlen(text));
  if (is_able(n)==true){
    tcolor=TEXT_COLOR;}
  else {
    tcolor=DISABLED_TEXT_COLOR;}

  color(n,tcolor);
  XDrawString(display,n->window,n->gc,/*(w-largeur)/2*/ 0,(h+struct_font->ascent)/2 -1,text,strlen(text));
}

void pp_item_redraw(Form *n){
  if (is_able(n)==true)
    _pp_item_redraw(n,normal);
  else
    _pp_item_redraw(n,mdisabled);
}

void pp_item_press(Form *n){
  if (is_able(n)==true)
    _pp_item_redraw(n,press); }

void pp_item_release(Form *i){
  if (is_able(i)==true){
    _pp_item_redraw(i,in);
    i->action(i);}
}

void pp_item_enter(Form *n) {
  if (is_able(n)==true)
    _pp_item_redraw(n,in); }


Form *popup(Form *parent,int nb,int w){
  Form *form;
  XSizeHints size;
  uint	n,b;
  XSetWindowAttributes attr;
  int h=struct_font->ascent+HSPACE;


  /***** Ouvre la fenetre  la main *****************************************************/
  form=(Form *)malloc(sizeof(Form));
  if (start_lst_obj==NULL){
    start_lst_obj=form;
    end_lst_obj=form;
  } else {
    end_lst_obj->next=form;		/*  Chaine la liste des formulaire  */
    end_lst_obj=form;
    form->next=NULL;
  }

  form->istype=tpopup; 
  form->redraw=nop;

  form->parent=NULL;
  
  b=WhitePixel(display,ecran);
  n=BlackPixel(display,ecran);		/* chope les couleurs noire et blanche */
  
  form->x=0;
  form->y=0;
  form->w=w;
  form->h=h*nb; 

  size.x=0;      size.y=0;		/* fixe la taille de la fenetre */
  size.width=w;	 size.height=h*nb;
  size.max_width=w;
  size.max_height=h*nb;
  size.min_width=w;	
  size.min_height=h*nb;
 
  size.flags=PPosition | PSize | PMinSize | PMaxSize;
 
  attr.override_redirect=True;
  attr.cursor=XCreateFontCursor(display,0x44);
  form->window = XCreateWindow(display,DefaultRootWindow(display),
			       size.x,size.y,size.width,size.height,1,
			       CopyFromParent,InputOutput,CopyFromParent,
			       CWOverrideRedirect|CWCursor,
			       &attr);

  XSetStandardProperties(display,form->window,"","",None,NULL,0,&size);
  form->gc = XCreateGC(display,form->window,0,NULL); /* cree le graphic context */
  XSetBackground(display,form->gc,n);
  XSetForeground(display,form->gc,b);
  XSetLineAttributes(display,form->gc,2,LineSolid,CapButt,JoinBevel);
  XSelectInput(display,form->window, ExposureMask); /* masque evnt */
  /******************************************** Fin de l'ouverture de la fenetre a la main ****/

  form->type.popup.items=calloc (nb+1,sizeof (Form *));
  form->type.popup.n=nb;;
  XSelectInput(display,form->window,0);

  return form;
}




Form *add_item(Form *popup,char *item,void (*action)(struct FORM *i)){
  Form *form;
  int h=struct_font->ascent+HSPACE;
  int i;

  for (i=0; i<popup->type.popup.n; i++){
    if (popup->type.popup.items[i]==0)
      break;
  }

  form=_open_form(popup,0,i*h,popup->w,h,0);


  form->istype=tpp_item;
  popup->type.popup.items[i]=form;

  if (action!=NULL)
    form->action=action;

  form->type.pp_item.text=(char *)malloc(strlen(item)+1);
  strcpy(form->type.pp_item.text,item);   
  form->redraw=pp_item_redraw;
  form->press=pp_item_press;
  form->release=pp_item_release;
  form->enter=pp_item_enter;
  form->leave=pp_item_redraw;

  XSelectInput(display,form->window, 
	       ExposureMask|
	       ButtonPressMask|ButtonReleaseMask|
	       EnterWindowMask|LeaveWindowMask);	/* masque evnt */
  
  return form;
}

void set_popup(Form *win,Form * popup){
  win->popup=popup;
}

void active_popup (Form * pp){
  pp->redraw(pp);		/* Redssine le bouton qui a appeller */
  XMoveWindow (display,pp->popup->window,event.xbutton.x_root,event.xbutton.y_root);
  view_window (pp->popup);
    XGrabPointer (display,pp->popup->window,True,ButtonPressMask|ButtonReleaseMask|
	       EnterWindowMask|LeaveWindowMask,
		GrabModeAsync,GrabModeAsync,
		None,None,CurrentTime);
}
