/******************************************************************************
DtK - DJedi Tool Kit. Un tool kit X Window
Copyright (C) 1998-1999 Valvassori Moise (djedi@citeweb.net)

Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon
les termes de la Licence Publique Gnrale GNU publie par la Free Software
Foundation (version 2 ou bien toute autre version ultrieure choisie par
vous).

Ce programme est distribu car potentiellement utile, mais SANS AUCUNE
GARANTIE, ni explicite ni implicite, y compris les garanties de
commercialisation ou d'adaptation dans un but spcifique. Reportez-vous  la
Licence Publique Gnrale GNU pour plus de dtails.

Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme
temps que ce programme ; si ce n'est pas le cas, crivez  la Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307,
tats-Unis.
******************************************************************************/
/******************************************************************************
               Dfinition des radios
******************************************************************************/
#define DJedi_radio

#include <stdio.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <stdlib.h>
#include "dtk.h"

extern Display *display;
extern XFontStruct *struct_font;
extern void nop();

static void _radio_redraw(Form *n,BMode type)
{
 int dummy,x,y,w,h,tcolor;
 char *text;

 XGetGeometry(display,n->window,(Window *)&dummy,&x,&y,&w,&h,&dummy,&dummy); 
 if (type==normal)
   color(n,BG_COLOR);
 else
   color(n,MOUSEON_BG_COLOR);   
 rectf(n,0,0,w,h);  /*   fond */

 color(n,LIGTH_COLOR);
 circlef(n,7,h/2,10);  /*   cercle */
 color(n,DARK_COLOR);
 circle(n,7,h/2,11);
 if (n->type.radio.value==true)
     circlef(n,7,h/2,7);

 text=n->type.radio.text;
 if (is_able(n)==true)
   tcolor=TEXT_COLOR;
 else
   tcolor=DISABLED_TEXT_COLOR;
 color(n,tcolor);
 XDrawString(display,n->window,n->gc,20,(h+struct_font->ascent)/2,text,strlen(text));
}

void radio_redraw(Form *n){
  _radio_redraw(n,normal);}

void radio_enter(Form *n){
  if (is_able(n)==true)
    _radio_redraw(n,in);}

void radio_release(Form *n)
{
  Form *ftmp;
  Window winpn;
  
  if ((n->type.radio.value==false) && (is_able(n)==true)){
    winpn=n->parent->window;
    for(ftmp=start_lst_obj; ftmp!=NULL; ftmp=ftmp->next){ /* cherche les autres radios qui ont la meme window mre */ 
      if ((ftmp->istype==tradio) && 
	  (ftmp->type.radio.value==true) && 
	  (ftmp->parent->window==winpn)) {
	ftmp->type.radio.value=false;
	_radio_redraw(ftmp,normal);
      }
    }
    n->type.radio.value=true;
    _radio_redraw(n,in);
    n->action(n);
  }
}

Form *radio(Form * parent,int x,int y,uint l, uint h,char *title,boolean value)
{
  Form *form;
  form=_open_form(parent,x,y,l,h,0);

  form->istype=tradio;
  form->redraw=radio_redraw;
  form->enter=radio_enter;
  form->leave=radio_redraw;
  form->release=radio_release;
  form->press=nop;
  form->type.radio.value=value;
  form->type.radio.text=(char *)malloc(strlen(title)+1);
  strcpy(form->type.radio.text,title);
  XSelectInput(display,form->window, 
			   ExposureMask|
			   EnterWindowMask|LeaveWindowMask|
			   ButtonReleaseMask|ButtonPressMask);	/* masque evnt */
  return form;
}


boolean get_radio(Form *f)
{
  if (f->istype==tradio)
    return f->type.radio.value;
  else
    return false;
}

boolean set_radio(Form *f,boolean v)
{
  if (f->istype==tradio){
    if (v==false){
      f->type.radio.value=v;
      _radio_redraw(f,normal);
    }else
      radio_release(f);
    return f->type.radio.value;
  }
  else
    return false;
}

char *set_radio_text(Form *f,char * text)
{
  if (f->istype==tradio){
    strcpy(f->type.radio.text,text);
    _radio_redraw(f,normal);
    return f->type.radio.text;
  }
  else
    return NULL;
}
