/******************************************************************************
DtK - DJedi Tool Kit. Un tool kit X Window
Copyright (C) 1998-1999 Valvassori Moise (djedi@citeweb.net)

Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon
les termes de la Licence Publique Gnrale GNU publie par la Free Software
Foundation (version 2 ou bien toute autre version ultrieure choisie par
vous).

Ce programme est distribu car potentiellement utile, mais SANS AUCUNE
GARANTIE, ni explicite ni implicite, y compris les garanties de
commercialisation ou d'adaptation dans un but spcifique. Reportez-vous  la
Licence Publique Gnrale GNU pour plus de dtails.

Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme
temps que ce programme ; si ce n'est pas le cas, crivez  la Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307,
tats-Unis.
******************************************************************************/
/*  DJedi Tool Box */
/* Gestion session X */

#define DJedi_SESSION

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include "dtk.h"
#include "form.h"


extern int Nb_win;
extern Form win[];

Display *display;
Font  font;
XFontStruct *struct_font;
Form *end_lst_obj,*start_lst_obj;
Colormap colormap;
int ecran;
XEvent event;

static char font_name[128]="8x13";

void (* default_Expose)       (XEvent event);
void (* default_ButtonRelease)(XEvent event);
void (* default_ButtonPress)  (XEvent event);
void (* default_LeaveNotify)  (XEvent event);
void (* default_EnterNotify)  (XEvent event);
void (* default_KeyPress)     (XEvent event);
void (* default_FocusIn)      (XEvent event);
void (* default_FocusOut)     (XEvent event);
void (* default_Motion)       (XEvent event);
void (* default_XEvent)       (XEvent event);


void nop_evnt(XEvent event){}

void init(int argc,char **argv)
{  
  char sdisplay[256]="";
  int i;

  for(i=0; i<argc; i++){
    if (strcmp(argv[i],"-display")==0)
      strcpy(sdisplay,argv[++i]);
  }

  display=XOpenDisplay(sdisplay);

  if (display==NULL){
    fprintf(stderr,"Can't open Display\n");
    exit(1);
  }

  font=XLoadFont(display,font_name);
  struct_font=XQueryFont(display,font);
  ecran=DefaultScreen(display);
  colormap=DefaultColormap(display,ecran);

  end_lst_obj=NULL;
  start_lst_obj=NULL;
  popup_active=NULL;

  TEXT_COLOR=get_color(TEXT);
  BG_COLOR=get_color(BG);
  MOUSEON_BG_COLOR=get_color(MOUSEON);
  MOUSEPRESS_BG_COLOR=get_color(MOUSEPRESS);
  LIGTH_COLOR=get_color(LIGTH);
  LIGTH_COLOR1=get_color(LIGTH1);
  LIGTH_COLOR2=get_color(LIGTH2);
  DARK_COLOR=get_color(DARK);
  DARK_COLOR1=get_color(DARK1);
  DARK_COLOR2=get_color(DARK2);
  BGINPUT_COLOR=get_color(BGINPUT);
  TEXTINPUT_COLOR=get_color(TEXTINPUT);
  DISABLED_TEXT_COLOR=get_color(TEXTDISABLED);
  DISABLED_BG_COLOR=get_color(DISABLED);

  default_Expose=nop_evnt;			  /* Evenement par defaut */
  default_ButtonRelease=nop_evnt;
  default_ButtonPress=nop_evnt;
  default_LeaveNotify=nop_evnt;
  default_EnterNotify=nop_evnt;
  default_KeyPress=nop_evnt;
  default_FocusIn=nop_evnt;
  default_FocusOut=nop_evnt;
  default_Motion=nop_evnt;
  default_XEvent=nop_evnt;
}

void DtK_config(Conf type,void *param){

  switch(type){
  case FONT:
    strcpy(font_name,(char *)param);
  break;
  }
}




void
one_event()
{
  Form *ftmp=NULL;
  
  XNextEvent(display,&event);					 /* attend l'evnt */
  switch (event.type)
    {
    case Expose:						 /* si redraw	*/
      if (event.xexpose.count==0)
	for(ftmp=start_lst_obj; 
	    ((event.xexpose.window!=ftmp->window) && (ftmp->next!=NULL)); 
	    ftmp=ftmp->next);
      if (ftmp!=NULL)
	ftmp->redraw(ftmp);					 /* appelle la fonction de redraw de cette partie du formulaire */
      else
	default_Expose(event);
      break;

    case ButtonRelease:						 /* Si on lache le bouton */
      for(ftmp=start_lst_obj; 
	  ((event.xbutton.window!=ftmp->window) && (ftmp->next!=NULL)); 
	  ftmp=ftmp->next);
      if ((ftmp!=NULL) && (event.xbutton.button==Button1)){
	if (((ftmp->istype==tpp_item) && (popup_active!=NULL)) ||
	    (popup_active==NULL))
	  ftmp->release(ftmp);					 /* appelle la fonction de d'action de cette partie du formulaire */
      } else
	default_ButtonRelease(event);
      break;
      
    case ButtonPress:						 /* Si on appuis sur le bouton */
      for(ftmp=start_lst_obj; 
	  ((event.xbutton.window!=ftmp->window) && (ftmp->next!=NULL)); 
	  ftmp=ftmp->next);
      if ((ftmp!=NULL) && (popup_active!=NULL) && (ftmp->istype!=tpp_item)) /* ordre d'valuation pas normalis */
	hide_window (popup_active);
      else{
	if (ftmp!=NULL){
	  if (event.xbutton.button==Button1){
	    if (((ftmp->istype==tpp_item) && (popup_active!=NULL)) ||
		(popup_active==NULL))
	      ftmp->press(ftmp);
	  }else if (event.xbutton.button==Button3){
	    if (ftmp->popup!=NULL)
	      active_popup (ftmp);
	  }
	  else
	    default_ButtonPress(event);
	}}
      break;

    case LeaveNotify:
      for(ftmp=start_lst_obj; 
	  ((event.xcrossing.window!=ftmp->window) && (ftmp->next!=NULL)); 
	  ftmp=ftmp->next);
      if (ftmp!=NULL){
	if (((ftmp->istype==tpp_item) && (popup_active!=NULL)) ||
	    (popup_active==NULL))
	  ftmp->leave(ftmp);
      }else
	default_LeaveNotify(event);
      break;

    case EnterNotify:
      for(ftmp=start_lst_obj; 
	  ((event.xcrossing.window!=ftmp->window) && (ftmp->next!=NULL)); 
	  ftmp=ftmp->next);
      if (ftmp!=NULL){
	if (((ftmp->istype==tpp_item) && (popup_active!=NULL)) ||
	    (popup_active==NULL))
	  ftmp->enter(ftmp);
      }
      else
	default_EnterNotify(event);
      break;

    case KeyPress:
      for(ftmp=start_lst_obj; 
	  ((event.xkey.window!=ftmp->window) && (ftmp->next!=NULL)); 
	  ftmp=ftmp->next);
      if (ftmp!=NULL){
	if (((ftmp->istype==tpp_item) && (popup_active!=NULL)) ||
	    (popup_active==NULL))
	  ftmp->kpress(ftmp,(XKeyEvent*)&event);
      }else
	default_KeyPress(event);
      break;

    case FocusIn:
      for(ftmp=start_lst_obj; 
	  ((event.xfocus.window!=ftmp->window) && (ftmp->next!=NULL)); 
	  ftmp=ftmp->next);
      if (ftmp!=NULL){
	if (((ftmp->istype==tpp_item) && (popup_active!=NULL)) ||
	    (popup_active==NULL))
	  ftmp->focus(ftmp,true);
      } else
	default_FocusIn(event);
      break;

    case FocusOut:
      for(ftmp=start_lst_obj; 
	  ((event.xfocus.window!=ftmp->window) && (ftmp->next!=NULL)); 
	  ftmp=ftmp->next);
      if (ftmp!=NULL){
	if (((ftmp->istype==tpp_item) && (popup_active!=NULL)) ||
	    (popup_active==NULL))
	  ftmp->focus(ftmp,false);
      }else
	default_FocusOut(event);
      break;

    case MotionNotify:
      for(ftmp=start_lst_obj; 
	  ((event.xmotion.window!=ftmp->window) && (ftmp->next!=NULL)); 
	  ftmp=ftmp->next);
      if (ftmp!=NULL){
	if (((ftmp->istype==tpp_item) && (popup_active!=NULL)) ||
	    (popup_active==NULL))
	  ftmp->motion(ftmp);
      }else
	default_Motion(event);
      break;

    default:
      default_XEvent(event);
    }
}





void 
loop(void)
{
  while(1)
    {	
      one_event();
    }
}


/*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  Exit the program and make a cleanup before exit

  int r the return code of the application
  +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
void DtK_end(int r)
{
  Form *ftmp,*ftmp2;
  ftmp2=start_lst_obj;

  for(ftmp=start_lst_obj->next; 
      (ftmp->next!=NULL); 
      ftmp=ftmp->next){
    free(ftmp2);
    ftmp2=ftmp;
  }

  XFreeFont(display,struct_font);
  XCloseDisplay(display);
  exit(r);
}
