/******************************************************************************
DtK - DJedi Tool Kit. Un tool kit X Window
Copyright (C) 1998-1999 Valvassori Mose (djedi@citeweb.net)

Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon
les termes de la Licence Publique Gnrale GNU publie par la Free Software
Foundation (version 2 ou bien toute autre version ultrieure choisie par
vous).

Ce programme est distribu car potentiellement utile, mais SANS AUCUNE
GARANTIE, ni explicite ni implicite, y compris les garanties de
commercialisation ou d'adaptation dans un but spcifique. Reportez-vous  la
Licence Publique Gnrale GNU pour plus de dtails.

Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme
temps que ce programme ; si ce n'est pas le cas, crivez  la Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307,
tats-Unis.
******************************************************************************/
/**********************************
 ************** Slider ************
 **********************************/
#define DJedi_slider

#include <stdio.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <stdlib.h>
#include "dtk.h"
#include "form.h"


static int mouse_motion,position_motion;

void _slider_redraw(Form *n,BMode type)
{
 int dummy,x,y,w,h;
 
 XGetGeometry(display,n->window,(Window *)&dummy,&x,&y,&w,&h,&dummy,&dummy); 
 if (is_able(n)==true)
   if (n->istype==tslider)
     _Box(n,x,y,w,h,press);
   else
     _Box(n,x,y,w,h,type);
 else
   if (n->istype==tslider)
     _Box(n,x,y,w,h,press);
   else
     /*     _Box(n,x,y,w,h,type);*/
   _Box(n,x,y,w,h,mdisabled);
}

void slider_redraw(Form *n){
  if (is_able(n)==true)
    _slider_redraw(n,normal);
  else
    _slider_redraw(n,mdisabled);
 }

void slider_press(Form *n){
  if (is_able(n)==true){
    if (n->istype==tslider_button){
      if (n->parent->type.slider.direction==horizontal)
	mouse_motion=event.xbutton.x_root;
      else
	mouse_motion=event.xbutton.y_root;
      position_motion=n->type.slider_button.position;
    }
    _slider_redraw(n,in);
  }
}

void slider_release(Form *i){
Form * t;
  if (is_able(i)==true){
    t=i->type.slider.slider;
    if (i->istype==tslider)
      if (i->type.slider.direction==horizontal){
	if (event.xbutton.x < t->x)
	  t->type.slider_button.position=
	    t->type.slider_button.position<SLIDER_STEP?
	    0:t->type.slider_button.position-SLIDER_STEP;
	else
	  t->type.slider_button.position=
	    t->type.slider_button.position>(SLIDER_MAX-SLIDER_STEP)?
	    SLIDER_MAX:t->type.slider_button.position+SLIDER_STEP;
	t->x=((i->w-2) - t->w)*t->type.slider_button.position/SLIDER_MAX;
	XMoveWindow(display,t->window,t->x,0);
      }
    else {
      if (event.xbutton.y < t->y)
	t->type.slider_button.position=
	  t->type.slider_button.position<SLIDER_STEP?
	  0:t->type.slider_button.position-SLIDER_STEP;
      else
	t->type.slider_button.position=
	  t->type.slider_button.position>(SLIDER_MAX-SLIDER_STEP)?
	  SLIDER_MAX:t->type.slider_button.position+SLIDER_STEP;
      t->y=((i->h-2) - t->h)*t->type.slider_button.position/SLIDER_MAX;
      XMoveWindow(display,t->window,0,t->y);
    }
    else				/* is_type==tslider_button */
    _slider_redraw(i,in);
    i->action(i);}
}

void slider_enter(Form *n) {
  if (is_able(n)==true)
    _slider_redraw(n,in); }

void slider_motion(Form *n){
  Form *p=n->parent;
  int mouse_position,position,flag;

  if (is_able(n)==true){
    if (p->type.slider.direction==horizontal){
      mouse_position=event.xbutton.x_root;
      position=position_motion+(mouse_position-mouse_motion)*SLIDER_MAX/((p->w-2) - n->w);
    }
    else {
      mouse_position=event.xbutton.y_root;
      position=position_motion+(mouse_position-mouse_motion)*SLIDER_MAX/((p->h-2) - n->h);
    }
    flag=0;
    if (position<0){
      position=0;
      flag=1;}
    else if (position>SLIDER_MAX){
      position=SLIDER_MAX;
      flag=1;}
    n->type.slider_button.position=position;
    if (p->type.slider.direction==horizontal){
      n->x=((p->w-2) - n->w)*n->type.slider_button.position/SLIDER_MAX;
      XMoveWindow(display,n->window,n->x,0);
    }
    else {
      n->y=((p->h-2) - n->h)*n->type.slider_button.position/SLIDER_MAX;
      XMoveWindow(display,n->window,0,n->y);
    }
    if (flag==0)
      n->action(n);	/* Appel "temps rel" */
  }
}
  
Form *slider(Form *parent,int x,int y,uint l,uint h,Direction direction,
	     int position,int size,void (*action)(Form *form))
{
  Form *form,*form1;
  int x1,y1,l1,h1;

  form=_open_form(parent,x,y,l,h,1);
  if (action==NULL)			/* Installe l'action du slider cliquer */
    form->action=nop;
  else
    form->action=action;

  form->istype=tslider;
  form->redraw=slider_redraw;
  form->enter=slider_enter;
  form->leave=slider_redraw;
  form->release=slider_release;
  form->press=slider_press;
  form->type.slider.direction=direction;
  
  XSelectInput(display,form->window, 
	       ExposureMask|
	       ButtonPressMask|ButtonReleaseMask|
	       EnterWindowMask|LeaveWindowMask);	/* masque evnt */
  
  /*............................................................*/
  if(direction==horizontal){		/* Calcule les coords initiales */
    y1=0;
    h1=h-2;
    l1=(l-4)*size/SLIDER_MAX;
    if (l1>(l-4))
      l1=l1-4;
    x1=((l-4)-l1)*position/SLIDER_MAX;
      }
  else {
    x1=0;
    l1=l-2;
    h1=(h-4)*size/SLIDER_MAX;
    if (h1>(h-4))
      h1=h1-4;
    y1=((h-4)-h1)*position/SLIDER_MAX;
  }
  
  form1=_open_form(form,x1,y1,l1,h1,1);
  form->type.slider.slider=form1;
  form1->type.slider_button.position=position;
  form1->type.slider_button.size=size;
  if (action==NULL)
    form1->action=nop;
  else
    form1->action=action;
  
  form1->istype=tslider_button;
  form1->redraw=slider_redraw;
  form1->enter=slider_enter;
  form1->leave=slider_redraw;
  form1->release=slider_release;
  form1->press=slider_press;
  form1->motion=slider_motion;
  
  XSelectInput(display,form1->window, 
	       ExposureMask|
	       ButtonPressMask|ButtonReleaseMask|
	       EnterWindowMask|LeaveWindowMask|
	       ButtonMotionMask);	/* masque evnt */
  
  return form;
 }

int get_slider_position(Form *win){
  if (win->istype==tslider)
    return (win->type.slider.slider->type.slider_button.position);
  else
    return (win->type.slider_button.position);
}

int get_slider_size(Form *win){
  if (win->istype==tslider)
    return (win->type.slider.slider->type.slider_button.size);
  else
    return (win->type.slider_button.size);
}

int set_slider_position(Form *win,int position){
Form * tmp;
  if (win->istype==tslider)
    win=win->type.slider.slider;

  if (win->istype==tslider_button){
    if (position>SLIDER_MAX)
      position=SLIDER_MAX;
    else if (position<0)
      position=0;
   
    tmp=win->parent;
    win->type.slider_button.position=position;
    if (tmp->type.slider.direction==horizontal){
      win->x=((tmp->w-2) - win->w)*win->type.slider_button.position/SLIDER_MAX;
      XMoveWindow(display,win->window,win->x,0);
    }
    else {
      win->y=((tmp->h-2) - win->h)*win->type.slider_button.position/SLIDER_MAX;
      XMoveWindow(display,win->window,0,win->y);
    }
    win->action(win);

    return (position);
  }
  else
    return(0);
}

int set_slider_size(Form *win,int size)
{
Form * tmp;
  if (win->istype==tslider)
    win=win->type.slider.slider;

  if (win->istype==tslider_button){
    if (size>SLIDER_MAX)
      size=SLIDER_MAX;
    else if (size<0)
      size=0;
   
    tmp=win->parent;
    win->type.slider_button.size=size;
    if (tmp->type.slider.direction==horizontal){
      win->w=(tmp->w-4)*size/SLIDER_MAX;
      win->x=((tmp->w-2) - win->w)*win->type.slider_button.position/SLIDER_MAX;
      XMoveResizeWindow(display,win->window,win->x,0,win->w,win->h);
    }
    else {
      win->h=(tmp->h)*size/SLIDER_MAX;
      win->y=((tmp->h-2) - win->h)*win->type.slider_button.position/SLIDER_MAX;
      XMoveResizeWindow(display,win->window,0,win->y,win->w,win->h);
    }
    win->action(win);

    return (size);
  }
  else
    return(0);
}







