/******************************************************************************
DtK - DJedi Tool Kit. Un tool kit X Window
Copyright (C) 1998-1999 Valvassori Moise (djedi@citeweb.net)

Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon
les termes de la Licence Publique Gnrale GNU publie par la Free Software
Foundation (version 2 ou bien toute autre version ultrieure choisie par
vous).

Ce programme est distribu car potentiellement utile, mais SANS AUCUNE
GARANTIE, ni explicite ni implicite, y compris les garanties de
commercialisation ou d'adaptation dans un but spcifique. Reportez-vous  la
Licence Publique Gnrale GNU pour plus de dtails.

Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme
temps que ce programme ; si ce n'est pas le cas, crivez  la Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307,
tats-Unis.
******************************************************************************/
/**********************************
 ************** Texte *************
 **********************************/
#define DJedi_text

#include <stdio.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <stdlib.h>
#include "dtk.h"
#include "form.h"

extern Display *display;
extern XFontStruct *struct_font;
extern void nop();

void text_redraw(Form *n)
{
  char *text;
  int dummy,x,y,w,h;
  int largeur,tcolor;
  
  XGetGeometry(display,n->window,(Window *)&dummy,&x,&y,&w,&h,&dummy,&dummy); 
  color(n,BG_COLOR);
  rectf(n,0,0,w,h);					    /*   fond */

 
  text=n->type.text.text; 
  
  switch (n->type.text.align) {
  case left:
    x=0;
    break;
  case center:
    largeur=XTextWidth(struct_font,text,strlen(text));
    x=(w-largeur)/2;
    break;
  case right:
    largeur=XTextWidth(struct_font,text,strlen(text));
    x=w-largeur;
    break;
  case align_error:
    fprintf(stderr,"Error Align\n");
  }
  
 if (is_able(n)==true)
   tcolor=TEXT_COLOR;
 else
   tcolor=DISABLED_TEXT_COLOR;
 color(n,tcolor);
  XDrawString(display,n->window,n->gc,x,(h+struct_font->ascent)/2,text,strlen(text));
}

Form *text(Form * parent,int x,int y,uint l,uint h,char *text,Align align)
{
  Form *form;
  form=_open_form(parent,x,y,l,h,0);
  
  form->istype=ttext;
  form->redraw=text_redraw;
  form->type.text.text=(char *)malloc(strlen(text)+1);
  strcpy(form->type.text.text,text);
  form->type.text.align=align;

  XSelectInput(display,form->window, 
	       ExposureMask);				    /* masque evnt */
  return form;
}

char *set_text(Form *f,char * text)
{
  if (f->istype==ttext){
    free(f->type.text.text);
    f->type.text.text=(char *)malloc(strlen(text)+1);
    strcpy(f->type.text.text,text);
    text_redraw(f);
    return f->type.text.text;
  }
  else
    return NULL;
}

Align set_text_justification(Form *f,Align a)
{
  if (f->istype==ttext){
    f->type.text.align=a;
    text_redraw(f);
    return f->type.text.align;
  }
  else
    return align_error;
}
