/******************************************************************************
DtK - DJedi Tool Kit. Un tool kit X Window
Copyright (C) 1998-1999 Valvassori Moise (djedi@citeweb.net)

Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon
les termes de la Licence Publique Gnrale GNU publie par la Free Software
Foundation (version 2 ou bien toute autre version ultrieure choisie par
vous).

Ce programme est distribu car potentiellement utile, mais SANS AUCUNE
GARANTIE, ni explicite ni implicite, y compris les garanties de
commercialisation ou d'adaptation dans un but spcifique. Reportez-vous  la
Licence Publique Gnrale GNU pour plus de dtails.

Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme
temps que ce programme ; si ce n'est pas le cas, crivez  la Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307,
tats-Unis.
******************************************************************************/
/*  DJedi Tool Box */
/* Gestion fenetre */

#define DJedi_FENETRE

#include <stdio.h>
#include <stdlib.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include "dtk.h"

Form * popup_active;

extern Display *display;

void nop(Form *win){}


/* Ouvre une nouvelle winetre */
Form *open_window(int x,int y,uint l,uint h,char * title,
		      void (*redraw)(Form *win))
{
  XSizeHints size;
  uint	n,b;
  Form *win;

  win=(Form *)malloc(sizeof(Form));
  if (start_lst_obj==NULL){
    start_lst_obj=win;
    end_lst_obj=win;
  } else {
    end_lst_obj->next=win;		/*  Chaine la liste des formulaire  */
    end_lst_obj=win;
    win->next=NULL;
  }

  win->istype=twindow; 
  if (redraw==NULL)
    win->redraw=nop;
  else
    win->redraw=redraw;			/* fixe le pointeur de redraw */

  win->parent=NULL;
  
  b=WhitePixel(display,ecran);
  n=BlackPixel(display,ecran);		/* chope les couleurs noire et blanche */
  
  win->x=x;
  win->y=y;
  win->w=l;
  win->h=h; 

 size.x=x;			size.y=y;	/* fixe la taille de la winetre */
 size.width=l;	size.height=h;
  size.max_width=l;
 size.max_height=h;
 size.min_width=l;	
 size.min_height=h;

 size.flags=PPosition | PSize | PMinSize | PMaxSize;
 
 	/* ouvre la window */
 win->window = XCreateSimpleWindow(display,DefaultRootWindow(display),
				   size.x,size.y,size.width,size.height,1,b,n);
 
 XSetStandardProperties(display,win->window,title,title,None,NULL,0,&size);
 /* XMapRaised(display,win->window);	*/
 	/* La window est visible maintenant	*/
 
 win->gc = XCreateGC(display,win->window,0,NULL);	/* cree le graphic context */
	XSetBackground(display,win->gc,n);
	XSetForeground(display,win->gc,b);
	XSetLineAttributes(display,win->gc,2,LineSolid,CapButt,JoinBevel);
	XSelectInput(display,win->window, ExposureMask);	/* masque evnt */
	
	return win;
}

void view_window(Form *win){
  XMapWindow(display,win->window);
  if (win->istype==tpopup){
    top_window (win);
    popup_active=win;
  }
}

void top_window(Form *win){
  XRaiseWindow(display,win->window);
}

void hide_window(Form *win){
  XUnmapWindow(display,win->window);
  if (win->istype==tpopup)
    popup_active=NULL;
}

void close_window(Form *win){		/* Do not use */
					/* Use hide_window instead */
  hide_window(win);
}

void default_redraw(Form *win){
int x,y,w,h,dummy;

 XGetGeometry(display,win->window,(Window *)&dummy,&x,&y,&w,&h,&dummy,&dummy); 
 color(win,BG_COLOR);
 rectf(win,0,0,w,h);
}













