/******************************************************************************
DtK - DJedi Tool Kit. Un tool kit X Window
Copyright (C) 1998-1999 Valvassori Moise (djedi@citeweb.net)

Ce programme est libre, vous pouvez le redistribuer et/ou le modifier selon
les termes de la Licence Publique Gnrale GNU publie par la Free Software
Foundation (version 2 ou bien toute autre version ultrieure choisie par
vous).

Ce programme est distribu car potentiellement utile, mais SANS AUCUNE
GARANTIE, ni explicite ni implicite, y compris les garanties de
commercialisation ou d'adaptation dans un but spcifique. Reportez-vous  la
Licence Publique Gnrale GNU pour plus de dtails.

Vous devez avoir reu une copie de la Licence Publique Gnrale GNU en mme
temps que ce programme ; si ce n'est pas le cas, crivez  la Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307,
tats-Unis.
******************************************************************************/
/******************************************************************************
               Test de Myers Briggs
******************************************************************************/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <dtk/dtk.h>

#define NB_QUESTION 70

int I=0,S=0,T=0,J=0;
int nb=1;
char t_question[80];
char t_question2[80];
char t_reponce1[80];
char t_reponce2[80];

Form *princ;
Form *resultat=NULL;
Form *nb_question;
Form *question;
Form *ra,*rb;

FILE *id;

int red,blue;
  

/* **************************************** */
void barrei(Form *i){
  color(i,red);
  rectf(i,0,0,(i->w)*I/10,i->h);
  color(i,blue);
  rectf(i,(i->w)*I/10,0,i->w,i->h);
	color(i,TEXT_COLOR);
	rect(i,0,0,i->w-1,i->h-1);
}
void barres(Form *i){
  color(i,red);
  rectf(i,0,0,(i->w)*S/20,i->h);
  color(i,blue);
  rectf(i,(i->w)*S/20,0,i->w,i->h);
	color(i,TEXT_COLOR);
	rect(i,0,0,i->w-1,i->h-1);
}
void barret(Form *i){
  color(i,red);
  rectf(i,0,0,(i->w)*T/20,i->h);
  color(i,blue);
  rectf(i,(i->w)*T/20,0,i->w,i->h);
	color(i,TEXT_COLOR);
	rect(i,0,0,i->w-1,i->h-1);
}
void barrej(Form *i){
  color(i,red);
  rectf(i,0,0,(i->w)*J/20,i->h);
  color(i,blue);
  rectf(i,(i->w)*J/20,0,i->w,i->h);
	color(i,TEXT_COLOR);
	rect(i,0,0,i->w-1,i->h-1);
}

void ferme_resultat(Form *i){
  hide_window(resultat);
}

void fin(Form *i){
  fclose(id);
  DtK_end(0);
}

void fresultat(void){
  Form *cadre;
  char te[80];
  
  hide_window(princ);
  resultat=open_window(0,0,600,270,"Myers Briggs Test Indicator"
		       ,default_redraw);
  button(resultat,10,230,580,30,"Ok",fin);
  text(resultat,10,10,580,30,"Rsultat",center);
  cadre=box(resultat,10,50,580,170,normal);
  sprintf(te,"I %d  -  %d E",I,10-I); /* Affiche les diffrents coefficient */
  text(cadre,10,10,120,30,te,center);
  sprintf(te,"N %d  -  %d S",S,20-S);
  text(cadre,10,40,120,30,te,center);
  sprintf(te,"T %d  -  %d F",T,20-T);
  text(cadre,10,70,120,30,te,center);
  sprintf(te,"J %d  -  %d P",J,20-J);
  text(cadre,10,100,120,30,te,center);

  subwindow(cadre,140,15,430,20,barrei);
  subwindow(cadre,140,45,430,20,barres);
  subwindow(cadre,140,75,430,20,barret);
  subwindow(cadre,140,105,430,20,barrej);

  sprintf(te,"Vous etes:");	/* Affiche le type */
  if (I<5)
    strcat(te,"E");
  else if (I>5)
    strcat(te,"I");
  else 
    strcat(te,"X");
  if (S<10)
    strcat(te,"S");
  else if (S>10)
    strcat(te,"N");
  else 
    strcat(te,"X");
  if (T<10)
    strcat(te,"F");
  else if (T>10)
    strcat(te,"T");
  else 
    strcat(te,"X");
  if (J<10)
    strcat(te,"P");
  else if (J>10)
    strcat(te,"J");
  else 
    strcat(te,"X");
  text(cadre,10,135,560,30,te,center);

  view_window(resultat);
}
/* ****************************** */
char * gicle_cr(char * text){	/* Vire les retours chariots en fin de ligne */
  char * ptr=text;
  for ( ; (*ptr != '\n') ; ptr++);
  if (*ptr=='\n')
    *ptr=0;
  return text;
}

void set_question(){		/* Place le texte des questions */
  char q[80];

  fgets(q,80,id); 
  set_text(question,gicle_cr(q));
  fgets(q,80,id); 
  set_radio_text(ra,gicle_cr(q));
  fgets(q,80,id); 
  set_radio_text(rb,gicle_cr(q));

}

void next(Form *i){
  if ((get_radio(ra)==true) || (get_radio(rb)==true))
    {
      if (nb<NB_QUESTION) {
	switch (nb%7){		/* Analyse la rponse */
	case 1:
	  if (get_radio(rb)==true)
	    I++;
	  break;
	case 2:
	  if (get_radio(rb)==true)
	    S++;
	  break;
	case 3:
	  if (get_radio(rb)==true)
	    S++;
	  break;
	case 4:
	  if (get_radio(ra)==true)
	    T++;
	  break;
	case 5:
	  if (get_radio(ra)==true)
	    T++;
	  break;
	case 6:
	  if (get_radio(ra)==true)
	    J++;
	  break;
	case 0:
	  if (get_radio(ra)==true)
	    J++;
	  break;
	}
	nb++;
	set_radio(ra,false);	/* Efface les Radios Boutons */
	set_radio(rb,false);
	sprintf(t_question,"Question %d",nb);
	set_text(nb_question,t_question);
	set_question();		/* Installe la prochaine question */
      }
      else if (resultat==NULL) {
	fresultat();		/* Fini -> affiche les resultats */
      }
    }
}
/* **************************************** */
char * strfill(char *t,int n){	/* Remplit une chaine t avec n char */
  int i;
  
  for(i=0; i<n; i++)
    t[i]='*';

  return t;
}
/* ************************************************** */

int main(int argc,char **argv){
  Form *cadre,*cadre_q;

  id=fopen("mb.txt","r");
  if (id==NULL){		/* Erreur  l'ouverture du fichier */
    fprintf(stderr,"Erreur  l'ouverture du fichier\n");
  }
  else				/* Fichier correctement ouvert */
    {
      init(argc,argv);		/* Go DtK, go */

      red=(int)get_color("Red"); /* Init les couleurs */
      blue=(int)get_color("blue");

      princ=open_window(0,0,640,225,"Myers Briggs Test Indicator"
			,default_redraw);
      cadre=box(princ,10,10,620,170,normal);
      cadre_q=box(cadre,10,80,600,80,normal);
      
      strfill(t_reponce1,79);
      ra=radio(cadre_q,10,10,580,30,t_reponce1,false);
      strfill(t_reponce2,79);
      rb=radio(cadre_q,10,40,580,30,t_reponce2,false);
      
      strcpy(t_question,"Question 1");
      nb_question=text(cadre,10,10,600,30,t_question,left);
      strfill(t_question2,79);
      question=text(cadre,10,40,600,30,t_question2,left);
      
      button(princ,540,190,90,25,"Quitter",fin);
      button(princ,10,190,520,25,"Prochaine question",next);
 
      set_question();		/* Set first question */

      view_window (princ);
      loop();
    }
  return (0);
}

