/*   link_list.h --- Interface DtK pour Guile
 *   
 *   Copyright (C) 2000 Valvassori Mose <djedi@altern.org>
 *   
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *   
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *   
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA **/

#ifndef LINK_LIST_H
#define LINK_LIST_H    /*+ To stop multiple inclusions. +*/


#ifdef EXTERN
#undef EXTERN
#endif
#ifndef LINK_LIST
#define EXTERN extern
#else
#define EXTERN
#endif



typedef struct LIST{
  void * data;
  struct LIST * next;
}LIST;


EXTERN LIST * llnew_list(void);
EXTERN int lldestroy_list(LIST *list);
EXTERN LIST* lladd2list(LIST* list,void *);
EXTERN void * llcar (LIST * l);
EXTERN LIST * llcdr (LIST *l);
EXTERN int llempty (LIST *l);
#endif /* LINK_LIST_H */
